/*
 * What does this program do? :-)
 */

#undef __STRICT_ANSI__

#include <sys/file.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *rot13(unsigned char *s)
{
	unsigned int i;
	unsigned char *p = s;
 	for (i = 0; i < strlen(s); ++i) {
		if (s[i] >= 'a' && s[i] <= 'z') {
 			s[i] = s[i] + 13;
 			if (s[i] > 'z')
 				s[i] = 'a' + s[i] - 'z' - 1;
		}
	}
	return p;
}

void do_dir(char *ep, char *d)
{
	char buf[1024], filename[1024], episode[128], package[128];
 	int i, nolevels;
	FILE *f;

 	strcpy(filename, ep);
 	strcat(filename, "/");
	strcat(filename, d);
 	strcat(filename, "/info.fxr");

	f = fopen(filename, "r");
	if (f == NULL)
		return;
	fgets(package, 128, f);
	package[strlen(package)-1] = '\0';
	if (strchr(package, ']')) {
  		strcpy(buf, strchr(package, ']') + 2);
  		strcpy(package, buf);
	}
	fgets(episode, 128, f);
	episode[strlen(episode)-1] = '\0';
	if (strchr(episode, ']')) {
  		strcpy(buf, strchr(episode, ']') + 2);
  		strcpy(episode, buf);
	}
	fscanf(f, "%d", &nolevels);
	fclose(f);
 	printf("\n*** %s - %s (%d levels) ***\n", package, episode, nolevels);
  	for (i = 0; i < nolevels; ++i) {
  		strcpy(filename, ep);
 		strcat(filename, "/");
		strcat(filename, d);
 		strcat(filename, "/map");
 		buf[0] = i + '0' + 1;
		buf[1] = '\0';
  		strcat(filename, buf);
  		strcat(filename, ".fxr");
		f = fopen(filename, "r");
		if (f == NULL)
			break;
	  	fgets(buf, 1024, f);
	  	fgets(buf, 1024, f);
		buf[strlen(buf)-1] = '\0';
		rot13(buf);
	  	fclose(f);
	  	printf("    %d: %s\n", i+1, buf);
	}
}

int main(int argc, char **argv)
{
	DIR *dir;
 	struct dirent *entry;

	if (argc != 2) {
		fprintf(stderr, "usage: lazyboy <episodespath>\n");
		return 1;
	}

	dir = opendir(argv[1]);
	if (dir == NULL) {
		fprintf(stderr, "Cannot load episodes from %s\n", argv[1]);
		return 1;
	}

	while ((entry = readdir(dir)) != NULL)
		do_dir(argv[1], entry->d_name);
	closedir(dir);

	return 0;
}

